package audio

type Source struct {
	SampleRate int
	Channels   int
	Blocks     chan []float32
}

func (s Source) Split(n int) (sources []Source) {
	sources = make([]Source, n)
	for i := range sources {
		sources[i] = s
		sources[i].Blocks = make(chan []float32, cap(s.Blocks))
	}

	go func() {
		defer func() {
			for i := range sources {
				close(sources[i].Blocks)
			}
		}()

		for block := range s.Blocks {
			for i := range sources {
				sources[i].Blocks <- block
			}
		}
	}()

	return
}
